var netcatEditareaFields = {
	id: {
		TemplateHeader: [
			"html", true, true, {				// syntax, SpecDisp, tabs, i18n
				ru: "Верхняя часть",
				en:	"Header"
			}
		],

		TemplateFooter: [
			"html",true, true, {
				ru: "Нижняя часть",
				en:	"Footer"
			}
		],

		ListPrefix: [
			"html", true, true, {
				ru: "Префикс списка",
				en:	"List prefix"
			}
		],

		ListBody: [
			"html", true, true, {
				ru: "Объект в списке",
				en:	"List body"
			}
		],

		ListSuffix: [
			"html", true, true, {
				ru: "Суффикс списка",
				en:	"List suffix"
			}
		],

		PageBody: [
			"html", true, true, {
				ru: "Отображение объекта",
				en:	"Page body"
			}
		],

		Settings: [
			"php", false, true, {
				ru: "Настройки",
				en:	"Settings"
			}
		],

		CustomSettings: [
			"php", false, true, {
				ru: "Визуальные настройки",
				en:	"Custom settings"
			}
		],
		
		AddForm: [
			"html", true, true, {
				ru: "Форма добавления",
				en:	"Add form"
			}
		],

		AddTemplate: [
			"html", true, true, {
				ru: "Форма добавления",
				en:	"Add form"
			}
		],

		AddCond: [
			"php", false, true, {
				ru: "Условие добавления",
				en:	"Add condition"
			}
		],

		AddActionTemplate: [
			"php", true, true, {
				ru: "Действие после добавления",
				en:	"Add action"
			}
		],
		
		EditForm: [
			"html", true, true, {
				ru: "Форма изменения",
				en:	"Edit form"
			}
		],

		EditTemplate: [
			"html", true, true, {
				ru: "Форма изменения",
				en:	"Edit form"
			}
		],

		EditCond: [
			"php", false, true, {
				ru: "Условие изменения",
				en:	"Edit condition"
			}
		],

		EditActionTemplate: [
			"php", true, true, {
				ru: "Действие после изменения",
				en:	"Edit action"
			}
		],

		CheckActionTemplate: [
			"php", true, true, {
				ru: "Действие после включения/выключения",
				en:	"On/off action"
			}
		],

		DeleteTemplate: [
			"html", true, true, {
				ru: "Форма удаления",
				en:	"Delete form"
			}
		],

		DeleteCond: [
			"php", false, true, {
				ru: "Условие удаления",
				en:	"Delete condition"
			}
		],

		DeleteActionTemplate: [
			"php", true, true, {
				ru: "Действие после удаления",
				en:	"Delete action"
			}
		],

		FullSearchTemplate: [
			"html", true, true, {
				ru: "Форма поиска перед списком",
				en:	"Search form before object list"
			}
		],

		SearchTemplate: [
			"html", true, true, {
				ru: "Форма расширенного поиска",
				en:	"Search form on single page"
			}
		],

		SubscribeCond: [
			"php", false, true, {
				ru: "Условие подписки",
				en:	"Subscribe condition"
			}
		],

		SendCond: [
			"php", false, true, {
				ru: "",
				en:	""
			}
		],

		SubscribeAction: [
			"html", false, true, {
				ru: "",
				en:	""
			}
		],

		Header: [
			"html", false, true, {
				ru: "",
				en:	""
			}
		],

		Record: [
			"html", false, true, {
				ru: "",
				en:	""
			}
		],

		Footer: [
			"html", false, true, {
				ru: "",
				en:	""
			}
		],

		SendCond: [
			"php", false, true, {
				ru: "",
				en:	""
			}
		],

		HTMLtext: [
			"html", false, true, {
				ru: "",
				en:	""
			}
		],

		Query: [
			"sql", false, false, {
				ru: "",
				en:	""
			}
		],
		
		Mirrors: [
			"robotstxt", false, true, {
				ru: "Зеркала",
				en:	"Mirrors"
			}
		],
		
		ncOfflineText: [
			"html", false, true, {
				ru: "Сайт выключен",
				en:	"Offline"
			}
		]
	},

	name: {
		Settings: [
			"php", false, true, {
				ru: "Настройки",
				en:	"Settings"
			}
		],

		CustomSettings: [
			"php", false, true, {
				ru: "Custom settings",
				en:	"Custom settings"
			}
		],

		Robots: [
			"robotstxt", false, true, {
				ru: "Robots.txt",
				en:	"Robots.txt"
			}
		]
	}
};

editAreaLoader.openedPressed = false; // Включен ли редим табов (может использоваться 1 на страницу)
editAreaLoader.openedPressedFillscreen = false; // Включен ли полноэкранный режим
editAreaLoader.getNetcatConfig = function() {
	return {
		id: 					'',
		start_highlight: 		true,
		smooth_selection: 		true,
		plugins: 				"zencoding",
		allow_resize: 			"y",
		allow_toggle: 			true,
		language: 				(ADMIN_LANG != "ru" ? ADMIN_LANG : ( NC_CHARSET == "utf-8" ? "ru_utf8" : "ru_cp1251")),
		syntax_selection_allow: "css,html,js,php,robotstxt,sql,xml",
		syntax: 				"php",
		toolbar: 				'search, go_to_line, |, undo, redo, |, select_font, |, syntax_selection, |, fullscreen, change_smooth_selection, highlight, reset_highlight, word_wrap, |, help',
		is_multi_files: 		false,
		save_callback: 			"save_editor_netcat",
		show_line_colors: 		true,
		font_size: 				"9",
		display: 				"later",
		debug: 					false,
		spec_disp: 				false,
		load_callback: 			"open_editor_netcat"
	};
};

netcat_editarea_configure_editor();

EditAreaLoader.prototype.window_loaded();

/**
 * Сохранение по Ctrl + Shift + S
 */
var aeForm_form = document.getElementsByTagName("FORM");
for (var i = 0; i < aeForm_form.length; i++) {
	aeForm_form[i].submitFirst = aeForm_form[i].submit;
	aeForm_form[i].onsubmit = (function(){
		return function(){
			// multiedit mode
			if(editAreaLoader.openedPressed) {
				for (var i in editAreas) {
					if (window.frames["frame_" + i] && editAreas[i]["displayed"] == true && window.frames["frame_" + i].editArea.fullscreen.isFull) {
						var _e = window.frames["frame_" + i].editArea;
						var files = _e.files;
						for(var j in files) {
							var file = files[j];
							var text = file.text;
							if(_e.curr_file == file.id) {
								text = _e.textarea.value;
							}
							document.getElementById(file.id).value = text;
							if (typeof window.frames["frame_" + file.id] != "undefined") {
								editAreas[file.id]["textarea"].value = text;
								if(file.id != _e.id) {
									var _e2 = window.frames["frame_" + file.id].editArea;
									_e2.textarea.value = text;
									_e2.resync_highlight(true);
									_e2.check_line_selection();
									delete _e2;
								}
							}
							_e.set_file_edited_mode(file.id, false);
						}
						delete _e;
					}
				}
			} else {
				for (var i in editAreas) {
					if (window.frames["frame_" + i] && editAreas[i]["displayed"] == true) {
						editAreas[i]["textarea"].value = window.frames["frame_" + i].editArea.textarea.value;
					}
				}
			}
			return true;
		};
	})();
	aeForm_form[i].submit = (function(){
		return function(){
			this.onsubmit();
			if (typeof this.edit_area_replaced_submit != 'function' || this.edit_area_replaced_submit()) {
				this.submitFirst();
			}
		};
	})();
}

/**
 * Добавление редактора на страницу
 */
function netcat_editarea_configure_editor(){
	var aeText_input = document.getElementsByTagName("TEXTAREA");
	for (var i = 0; i < aeText_input.length; i++) {
		var id = aeText_input[i].id;
		var conf = editAreaLoader.getNetcatConfig();
		
		conf.id 				= id;
		conf.toolbar 			= '';
		conf.toolbar_default 	= ((id != "Query") ? "save, " : "") + "search, go_to_line, |, undo, redo, |, select_font, |, syntax_selection, |, fullscreen, change_smooth_selection, highlight, reset_highlight, word_wrap, |, help";
		conf.toolbar_tabs	 	= ((id != "Query") ? "save, " : "") + "search, go_to_line, |, undo, redo, |, select_font, |, syntax_selection, |, fullscreen, load, change_smooth_selection, highlight, reset_highlight, word_wrap, |, help";

		// search in netcatEditareaFields by id
		if (aeText_input[i].id && typeof netcatEditareaFields.id[id] == "object") {
			var o = netcatEditareaFields.id[id];

			conf.syntax 	= o[0];
			conf.spec_disp 	= o[1];
			conf.toolbar	= o[2] ? conf.toolbar_tabs : conf.toolbar_default;

			delete o;
		}

		// search in netcatEditareaFields by name
		if (!conf.toolbar) {
			var name = aeText_input[i].getAttribute("name");
			if(name && typeof netcatEditareaFields.name[name] == "object") {
				var o = netcatEditareaFields.name[name];

				// generate id
				id = '';
				for (var j = 0; j <= 32; j++) {
					id += String.fromCharCode(Math.floor(Math.random() * 26) + 65);
				}

				aeText_input[i].id 	= id;
				conf.id				= id;
				conf.syntax 		= o[0];
				conf.spec_disp 		= o[1];
				conf.toolbar		= o[2] ? conf.toolbar_tabs : conf.toolbar_default;

				delete o;
			}
		}

		// http://www.cdolivet.net/editarea/
		if (conf.toolbar) {
			editAreaLoader.init(conf);
		}
	}
}

/**
 * Нажатие на иконку сохранения в EditArea
 */
function save_editor_netcat(id, content){
	var form 	= document.getElementById(id).form;
	var files 	= editAreaLoader.getAllFiles(id);

	for(i in files) {
		var file = files[i];

		// save to form textarea
		form[file.id].value = file.text;

		// save to editarea, if it open
		if(typeof window.frames["frame_" + file.id] != "undefined") {
			editAreas[file.id]["textarea"].value = file.text;
			if(file.id != id) {
				var _e = window.frames["frame_" + file.id].editArea;
				_e.textarea.value = file.text;
				_e.resync_highlight(true);
				_e.check_line_selection();
				delete _e;
			}
		}

		// visual effects
		editAreaLoader.execCommand(id, 'set_file_edited_mode', file.id, false);
	}
	form.onsubmit();
	formAsyncSave(form);
}

// Заменим функцию асинхронного сохранения формы
/*var formAsyncSaveOriginal = formAsyncSave;
formAsyncSave = function(form){
	form.onsubmit();
	return formAsyncSaveOriginal(form);
};*/

// Функция вызывается при ресайзе визуального редактора
function resize_all_editareas(){
	if (typeof editAreas == 'object') {
		for (var i in editAreas) {
			if (window.frames["frame_" + i] && editAreas[i]["displayed"] == true && window.frames["frame_" + i].editArea.fullscreen['isFull'] == false) {
				editAreaLoader.toggle(i);
				editAreaLoader.toggle(i);
			}
		}
	}
}

/**
 * Функция вызывается при открытии табов
 */
function open_editor_netcat(id) {
	var form 		= document.getElementById(id).form;
	var elements 	= form.getElementsByTagName("TEXTAREA");

	// Exit from tab-mode
	if (editAreaLoader.openedPressed) {
		editAreaLoader.openedPressed = false;

		editAreaLoader.execCommand(id, 'switch_to_file', id);
		var files = editAreaLoader.getAllFiles(id);
		for (i in files) {
			var file = files[i];
			if(file.id != id) {
				editAreaLoader.execCommand(id, "close_file", file.id);
			}
		}

		var _e = window.frames["frame_" + id].editArea;
		_e.tab_browsing_area.style.display= "none";
		_e.update_size();

		if (!editAreaLoader.openedPressedFillscreen) {
			editAreaLoader.execCommand(id, 'toggle_full_screen', false);
		}
	}

	// Switch to tab-mode
	else {
		// if EditArea have any files, close it (can stay from previous tab-mode executions)
		var files = editAreaLoader.getAllFiles(id);
		
		// if does not pressed the open button tabs before, need to update the contents of value
		var filesCounter = 0;
		for (i in files) {
			filesCounter++;
		}
		if(!filesCounter) {
			for (var i in editAreas) {
				if (window.frames["frame_" + i] && editAreas[i]["displayed"] == true) {
					editAreas[i]["textarea"].value = window.frames["frame_" + i].editArea.textarea.value;
				}
			}
		}
		delete filesCounter;
		
		for (i in files) {
			var file = files[i];
			form[file.id].value = file.text;
			editAreaLoader.execCommand(id, "close_file", file.id);
		}
		delete files;

		var j = 1;
		for (i in elements) {
			var el = elements[i];

			// if EditArea not allowed for current element
			if (!el.id) continue;

			var options = {
				id: 		'',
				text: 		el.value,
				syntax: 	'php',
				title: 		'',
				spec_disp: 	false
			};

			// get language for element
			var o = false;
			if (typeof netcatEditareaFields.id[el.id] == "object") {
				var o = netcatEditareaFields.id[el.id];
				options.title = el.id;
			} else {
				if (typeof netcatEditareaFields.name[el.name] == "object") {
					var o = netcatEditareaFields.name[el.name];
					options.title = el.name;
				}
			}

			if(typeof o != "object") {
				continue;
			}

			options.id			= el.id;
			options.syntax 		= o[0];
			options.title 		= o[3][ADMIN_LANG] ? o[3][ADMIN_LANG] : ( o[3].en ? o[3].en : conf.title ) ;
			options.spec_disp 	= o[1];

			options.title = j.toString() + ". " + options.title;
			options.title = options.title.replace(/\s/gi, "&nbsp;");

			// open file
			editAreaLoader.openFile(id, options);
			delete o; 
			delete el;
			j++;
		}

		editAreaLoader.execCommand(id, 'switch_to_file', id);

		editAreaLoader.openedPressedFillscreen = window.frames["frame_" + id].editArea.fullscreen['isFull'];
		if (!editAreaLoader.openedPressedFillscreen) {
			editAreaLoader.execCommand(id, 'toggle_full_screen', true);
		}

		editAreaLoader.openedPressed = true;
	}
	
	return true;
}

if(typeof EditAreaCallback != "undefined") {
	for(i in EditAreaCallback) {
		if(typeof EditAreaCallback[i] == "function");
		EditAreaCallback[i]();
	}
}